<?php

namespace Lc\CaracoleBundle\Container\PointSale;

use Lc\CaracoleBundle\Factory\PointSale\PointSaleFactory;
use Lc\CaracoleBundle\Repository\PointSale\PointSaleRepositoryQuery;
use Lc\CaracoleBundle\Repository\PointSale\PointSaleStore;

class PointSaleContainer
{
    protected PointSaleFactory $factory;
    protected PointSaleRepositoryQuery $repositoryQuery;
    protected PointSaleStore $store;

    public function __construct(
            PointSaleFactory $factory,
            PointSaleRepositoryQuery $repositoryQuery,
            PointSaleStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): PointSaleFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): PointSaleRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): PointSaleStore
    {
        return $this->store;
    }

}