<?php

namespace Lc\CaracoleBundle\Container\Product;

use Lc\CaracoleBundle\Factory\Product\ProductFamilyFactory;
use Lc\CaracoleBundle\Repository\Product\ProductFamilyRepositoryQuery;
use Lc\CaracoleBundle\Repository\Product\ProductFamilyStore;

class ProductFamilyContainer
{
    protected ProductFamilyFactory $factory;
    protected ProductFamilyRepositoryQuery $repositoryQuery;
    protected ProductFamilyStore $store;

    public function __construct(
            ProductFamilyFactory $factory,
            ProductFamilyRepositoryQuery $repositoryQuery,
            ProductFamilyStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): ProductFamilyFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): ProductFamilyRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): ProductFamilyStore
    {
        return $this->store;
    }

}