<?php

namespace Lc\CaracoleBundle\Container\User;

use Lc\CaracoleBundle\Factory\User\UserMerchantFactory;
use Lc\CaracoleBundle\Repository\User\UserMerchantRepositoryQuery;
use Lc\CaracoleBundle\Repository\User\UserMerchantStore;

class UserMerchantContainer
{
    protected UserMerchantFactory $factory;
    protected UserMerchantRepositoryQuery $repositoryQuery;
    protected UserMerchantStore $store;

    public function __construct(
            UserMerchantFactory $factory,
            UserMerchantRepositoryQuery $repositoryQuery,
            UserMerchantStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): UserMerchantFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): UserMerchantRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): UserMerchantStore
    {
        return $this->store;
    }

}