<?php

namespace Lc\CaracoleBundle\Container\User;

use Lc\CaracoleBundle\Factory\User\VisitorFactory;
use Lc\CaracoleBundle\Repository\User\VisitorRepositoryQuery;
use Lc\CaracoleBundle\Repository\User\VisitorStore;

class VisitorContainer
{
    protected VisitorFactory $factory;
    protected VisitorRepositoryQuery $repositoryQuery;
    protected VisitorStore $store;

    public function __construct(
            VisitorFactory $factory,
            VisitorRepositoryQuery $repositoryQuery,
            VisitorStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): VisitorFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): VisitorRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): VisitorStore
    {
        return $this->store;
    }

}