<?php

namespace Lc\CaracoleBundle\Model\Product;


use Doctrine\Common\Collections\Collection;
use Lc\CaracoleBundle\Model\Section\SectionInterface;

/**
 * @ORM\MappedSuperclass()
 */
interface ProductCategoryInterface
{
    public function getSection(): SectionInterface;

    public function setSection(SectionInterface $section): \Lc\CaracoleBundle\Model\Product\ProductCategoryModel;

    public function getParent(): ?self;

    public function setParent(?self $productCategory): \Lc\CaracoleBundle\Model\Product\ProductCategoryModel;

    public function getParentCategory();

    /**
     * @return Collection|self[]
     */
    public function getChildrens(): Collection;

    public function addChildren(self $productCategory): \Lc\CaracoleBundle\Model\Product\ProductCategoryModel;

    public function removeChildren(self $productCategory): \Lc\CaracoleBundle\Model\Product\ProductCategoryModel;

    /**
     * @return Collection|ProductFamilyInterface[]
     */
    public function getProductFamilies(): Collection;

    public function addProductFamily(ProductFamilyInterface $productFamily
    ): \Lc\CaracoleBundle\Model\Product\ProductCategoryModel;

    public function removeProductFamily(ProductFamilyInterface $productFamily
    ): \Lc\CaracoleBundle\Model\Product\ProductCategoryModel;

    public function countProductFamilies($status = null);

    public function getSaleStatus(): ?bool;

    public function setSaleStatus(bool $saleStatus): \Lc\CaracoleBundle\Model\Product\ProductCategoryModel;
}