<?php

namespace Lc\CaracoleBundle\Model\Product;


use Lc\CaracoleBundle\Model\Order\OrderShopInterface;

/**
 * @ORM\MappedSuperclass()
 */
interface ProductInterface
{
    public function getQuantityMaxAddCart(OrderShopInterface $orderShop);

    public function getProductQuantity();

    public function getBuyingPriceInherited();

    public function getBuyingPriceByRefUnitInherited();

    public function getPriceInherited();

    public function getPriceByRefUnitInherited();

    public function getBehaviorPriceInherited();

    public function getReductionCatalogInherited();

    public function getUnitInherited();

    public function getTitleInherited();

    public function getQuantityInherited();

    public function getQuantityLabelInherited();

    public function getQuantityTitle($productFamily);

    public function getAvailableQuantityInherited();

    public function getTaxRateInherited();

    public function getProductFamily(): ?ProductFamilyInterface;

    public function setProductFamily(?ProductFamilyInterface $productFamily
    ): \Lc\CaracoleBundle\Model\Product\ProductModel;

    public function getTitle(): ?string;

    public function setTitle(?string $title): \Lc\CaracoleBundle\Model\Product\ProductModel;

    public function getOriginProduct(): ?bool;

    public function setOriginProduct(?bool $originProduct): \Lc\CaracoleBundle\Model\Product\ProductModel;

    public function getExportTitle(): ?string;

    public function getExportTitleInherited(): ?string;

    public function setExportTitle(?string $exportTitle): \Lc\CaracoleBundle\Model\Product\ProductModel;

    public function getExportNote(): ?string;

    public function getExportNoteInherited(): ?string;

    public function setExportNote(?string $exportNote): \Lc\CaracoleBundle\Model\Product\ProductModel;
}